View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.core.write;
    21
    22  import org.apache.mina.core.session.IoSession;
    23
    24  /**
    25   * Stores {@link WriteRequest}s which are queued to an {@link IoSession}.
    26   *
    27   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    28   */
    29  public interface WriteRequestQueue {
    30
    31      /**
    32       * Get the first request available in the queue for a session.
    33       * @param session The session
    34       * @return The first available request, if any.
    35       */
    36      WriteRequest poll(IoSession session);
    37
    38      /**
    39       * Add a new WriteRequest to the session write's queue
    40       * @param session The session
    41       * @param writeRequest The writeRequest to add
    42       */
    43      void offer(IoSession session, WriteRequest writeRequest);
    44
    45      /**
    46       * Tells if the WriteRequest queue is empty or not for a session
    47       * @param session The session to check
    48       * @return <code>true</code> if the writeRequest is empty
    49       */
    50      boolean isEmpty(IoSession session);
    51
    52      /**
    53       * Removes all the requests from this session's queue.
    54       * @param session The associated session
    55       */
    56      void clear(IoSession session);
    57
    58      /**
    59       * Disposes any releases associated with the specified session.
    60       * This method is invoked on disconnection.
    61       * @param session The associated session
    62       */
    63      void dispose(IoSession session);
    64
    65      /**
    66       * Returns the number of objects currently stored in the queue.
    67       * @return
    68       */
    69      int size();
    70  }